Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/searchpanel/SearchFieldController.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/searchpanel/SearchFieldController.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/searchpanel/SearchFieldController.java	(revision 44259)
@@ -0,0 +1,329 @@
+package org.gvsig.fmap.dal.swing.impl.searchpanel;
+
+import java.awt.Cursor;
+import java.awt.event.ItemEvent;
+import java.awt.event.ItemListener;
+import java.awt.event.MouseAdapter;
+import java.awt.event.MouseEvent;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+import java.util.Objects;
+import javax.swing.ComboBoxModel;
+import javax.swing.DefaultComboBoxModel;
+import javax.swing.JComboBox;
+import javax.swing.JLabel;
+import org.apache.commons.lang3.ObjectUtils;
+import org.apache.commons.lang3.StringUtils;
+import org.gvsig.expressionevaluator.ExpressionBuilder;
+import org.gvsig.fmap.dal.feature.Feature;
+import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
+import org.gvsig.fmap.dal.feature.FeatureSet;
+import org.gvsig.fmap.dal.feature.FeatureStore;
+import org.gvsig.fmap.dal.feature.FeatureType;
+import org.gvsig.tools.dataTypes.CoercionException;
+import org.gvsig.tools.dataTypes.DataTypesManager;
+import org.gvsig.tools.exception.BaseException;
+import org.gvsig.tools.swing.api.DropDown;
+import org.gvsig.tools.swing.api.ToolsSwingLocator;
+import org.gvsig.tools.swing.api.ToolsSwingManager;
+import org.gvsig.tools.util.LabeledValue;
+import org.gvsig.tools.util.LabeledValueImpl;
+import org.gvsig.tools.visitor.VisitCanceledException;
+import org.gvsig.tools.visitor.Visitor;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+@SuppressWarnings("UseSpecificCatch")
+public class SearchFieldController {
+
+    private static class FeatureAttribute extends LabeledValueImpl<String> {
+
+        FeatureAttributeDescriptor attrdesc;
+
+        public FeatureAttribute(FeatureAttributeDescriptor attrdesc) {
+            this(attrdesc, null, null);
+        }
+        
+        public FeatureAttribute(FeatureAttributeDescriptor attrdesc, String label, String value) {
+            super(
+                    ObjectUtils.defaultIfNull(label, attrdesc.getLabel()), 
+                    ObjectUtils.defaultIfNull(value, attrdesc.getName())
+            );
+            this.attrdesc = attrdesc;
+        }
+        
+        public FeatureAttributeDescriptor getDescriptor() {
+            return this.attrdesc;
+        }
+        
+        public boolean isExpression() {
+            FeatureType type = this.attrdesc.getFeatureType();
+            if( type == null ) {
+                return false;
+            }
+            Object x = type.get(this.getValue());
+            return x==null;
+        }
+
+    }
+
+    private FeatureStore store;
+    private final JLabel lblFields;
+    private final JLabel lblExtraFields;
+    private final JLabel lblLogicalOperators;
+    private final JLabel lblRelationalOperators;
+    private final JComboBox cboValue;
+
+    private DropDown ddnFields;
+    private DropDown ddnLogicalOperators;
+    private DropDown ddnRelationalOperators;
+
+
+
+    private final LabeledValue[] relationalOperators = {
+        new LabeledValueImpl("Equals to", ExpressionBuilder.OPERATOR_EQ),
+        new LabeledValueImpl("Like to", ExpressionBuilder.OPERATOR_ILIKE),
+        new LabeledValueImpl("Not equals to", ExpressionBuilder.OPERATOR_NE),
+        new LabeledValueImpl("Greater than", ExpressionBuilder.OPERATOR_GT),
+        new LabeledValueImpl("Greater or equal to", ExpressionBuilder.OPERATOR_GE),
+        new LabeledValueImpl("Less than", ExpressionBuilder.OPERATOR_LT),
+        new LabeledValueImpl("Less or equal to", ExpressionBuilder.OPERATOR_LE)
+    };
+    private final LabeledValue[] logicalOperators = {
+        new LabeledValueImpl("Or", ExpressionBuilder.OPERATOR_OR),
+        new LabeledValueImpl("And", ExpressionBuilder.OPERATOR_AND)
+    };
+
+    public SearchFieldController(
+            FeatureStore store,
+            JLabel lblFields,
+            JLabel lblExtraFields,
+            JLabel lblRelationalOperators,
+            JComboBox cboValue,
+            JLabel lblLogicalOperators
+    ) {
+        this.store = store;
+        this.lblFields = lblFields;
+        this.lblExtraFields = lblExtraFields;
+        this.lblRelationalOperators = lblRelationalOperators;
+        this.cboValue = cboValue;
+        this.lblLogicalOperators = lblLogicalOperators;
+        this.initComponents();
+    }
+
+    private void initComponents() {
+        try {
+            ToolsSwingManager toolsSwingManager = ToolsSwingLocator.getToolsSwingManager();
+            this.lblExtraFields.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
+
+            this.ddnFields = toolsSwingManager.createDropDown(lblFields);
+            this.ddnRelationalOperators = toolsSwingManager.createDropDown(lblRelationalOperators);
+            if( lblLogicalOperators!=null ) {
+                this.ddnLogicalOperators = toolsSwingManager.createDropDown(lblLogicalOperators);
+            }
+
+            DefaultComboBoxModel modelRelationalOperators = new DefaultComboBoxModel();
+            for (LabeledValue op : relationalOperators) {
+                modelRelationalOperators.addElement(op);
+            }
+            this.ddnRelationalOperators.setModel(modelRelationalOperators);
+
+            if( this.ddnLogicalOperators!=null ) {
+                DefaultComboBoxModel modelLogicalOperators = new DefaultComboBoxModel();
+                for (LabeledValue op : logicalOperators) {
+                    modelLogicalOperators.addElement(op);
+                }
+                this.ddnLogicalOperators.setModel(modelLogicalOperators);
+            }
+            
+            List<FeatureAttributeDescriptor> orderedAttributes = SearchUtils.getOrderedAttributes(
+                    this.store, 
+                    SearchUtils.BASIC_TYPES_FILTER,
+                    SearchUtils.STR_INT_LONG_LABEL_ORDER,
+                    20
+            );
+            DefaultComboBoxModel model = new DefaultComboBoxModel();
+            for (FeatureAttributeDescriptor attrdesc : orderedAttributes) {
+                model.addElement(new FeatureAttribute(attrdesc));
+            }
+
+            this.ddnFields.setModel(model);
+            this.ddnFields.addItemListener(new ItemListener() {
+                @Override
+                public void itemStateChanged(ItemEvent e) {
+                    if (e.getStateChange() == ItemEvent.SELECTED) {
+                        doUpdateValuesList();
+                    }
+
+                }
+            });
+            
+            this.lblExtraFields.addMouseListener(new MouseAdapter() {
+                @Override
+                public void mouseClicked(MouseEvent e) {
+                    doSelectExtraField();
+                }
+            });
+            clear();
+        } catch (Exception ex) {
+            throw new RuntimeException(ex);
+        }
+    }
+
+    private void doSelectExtraField() {
+        
+    }
+    
+    public void clear() {
+        this.ddnRelationalOperators.setSelectedIndex(0);
+        if( this.ddnLogicalOperators!=null ) {
+            this.ddnLogicalOperators.setSelectedIndex(0);
+        }
+        this.cboValue.setSelectedIndex(-1);
+    }
+    
+    private void doUpdateValuesList() {
+        final FeatureAttribute attribute = (FeatureAttribute) this.ddnFields.getSelectedItem();
+        if( attribute==null ) {
+            return;
+        }        
+        final List<Object> values = new ArrayList<>();
+        final int limit = 60;
+        final long timeLimit = System.currentTimeMillis() + limit * 1000;
+        try {
+            FeatureSet set = this.store.getFeatureSet();
+            set.accept(new Visitor() {
+                @Override
+                public void visit(Object o) throws VisitCanceledException, BaseException {
+                    Object value = ((Feature) o).get(attribute.getDescriptor().getName());
+                    if (!values.contains(value)) {
+                        values.add(value);
+                    }
+                    if (System.currentTimeMillis() > timeLimit) {
+                        throw new VisitCanceledException();
+                    }
+                    if (values.size()>1000 ) {
+                        throw new VisitCanceledException();
+                    }
+                }
+            });
+        } catch (VisitCanceledException ex) {
+
+        } catch (Exception ex) {
+            // FIXME
+        }
+        List<LabeledValue> elements = new ArrayList<>();
+        if (!values.isEmpty()) {
+            LabeledValue[] availableValues = attribute.getDescriptor().getAvailableValues();
+            Map<String, String> availableValuesMap = new HashMap<>();
+            if (availableValues != null) {
+                for (LabeledValue availableValue : availableValues) {
+                    availableValuesMap.put(
+                            Objects.toString(availableValue.getValue()),
+                            availableValue.getLabel()
+                    );
+                }
+            }
+            elements.add(new LabeledValueImpl("", null));
+            for (Object value : values) {
+                String key = Objects.toString(value);
+                String label = availableValuesMap.getOrDefault(key, key);
+                elements.add(new LabeledValueImpl(label, value));
+            }
+        }
+        DefaultComboBoxModel model = new DefaultComboBoxModel();
+        for (LabeledValue element : elements) {
+            model.addElement(element);
+        }
+        this.cboValue.setModel(model);
+    }
+
+    public String getRelationalOperator() {
+        LabeledValue<String> op = (LabeledValue) this.ddnRelationalOperators.getSelectedItem();
+        if( op == null ) {
+            return null;
+        }
+        return op.getValue();
+    }
+    
+    public String getLogicalOperator() {
+        if( this.ddnLogicalOperators==null ) {
+            return null;
+        }
+        LabeledValue<String> rel = (LabeledValue) this.ddnLogicalOperators.getSelectedItem();
+        if( rel == null ) {
+            return null;
+        }
+        return rel.getValue();
+    }
+    
+    public Object getValue() {
+        final FeatureAttribute attribute = (FeatureAttribute) this.ddnFields.getSelectedItem();
+        if( attribute==null ) {
+            return null;
+        }
+        Object v = this.cboValue.getSelectedItem();
+        if( v == null ) {
+            return null;
+        }
+        if( v instanceof LabeledValue ) {
+            v = ((LabeledValue)v).getValue();
+            if( v == null ) {
+                return null;
+            }
+        }
+        if( v instanceof CharSequence ) {
+            if( StringUtils.isBlank((CharSequence) v)) {
+                return null;
+            }
+        }
+        DataTypesManager.Coercion coercion = attribute.getDescriptor().getDataType().getCoercion();
+        try {
+            return coercion.coerce(v);
+        } catch (CoercionException ex) {
+            return null;
+        }
+    }
+    
+    public boolean isAttributeAnExpression() {
+        final FeatureAttribute attribute = (FeatureAttribute) this.ddnFields.getSelectedItem();
+        if( attribute==null ) {
+            return false;
+        }
+        return attribute.isExpression();
+    }
+    
+    public String getAttribute() {
+        final FeatureAttribute attribute = (FeatureAttribute) this.ddnFields.getSelectedItem();
+        if( attribute==null ) {
+            return null;
+        }
+        SearchUtils.getRecentUseds().add(attribute.getDescriptor());
+        return attribute.getValue();
+    }
+    
+    public void setAttribute(String name) {
+        ComboBoxModel<FeatureAttribute> model = this.ddnFields.getModel();
+        for (int i = 0; i < model.getSize(); i++) {
+            FeatureAttribute x = model.getElementAt(i);
+            if( StringUtils.equalsIgnoreCase(name, x.getLabel())) {
+                this.ddnFields.setSelectedIndex(i);
+                return;
+            }
+        }
+        this.ddnFields.setSelectedIndex(-1);
+    }
+    
+    public void setAttribute(int index) {
+        try {
+            this.ddnFields.setSelectedIndex(index);
+        } catch(Exception ex) {
+            this.ddnFields.setSelectedIndex(-1);
+        }
+    }
+    
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/featuretype/DefaultFeatureTypeAttributePanel.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/featuretype/DefaultFeatureTypeAttributePanel.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/featuretype/DefaultFeatureTypeAttributePanel.java	(revision 44259)
@@ -414,11 +414,9 @@
         this.txtMaxValue.setEnabled(false);
         
         this.btnVirtualField.setText("");
+        this.featureStoreElement = dataSwingManager.createFeatureStoreElement();
         this.pickerVirtualField = ExpressionEvaluatorSwingLocator.getManager()
                 .createExpressionPickerController(txtVirtualField, btnVirtualField);
-        this.featureStoreElement = dataSwingManager.createFeatureStoreElement(
-                this.pickerVirtualField
-        );
         this.pickerVirtualField.addElement(this.featureStoreElement);
         this.chkVirtualField.addChangeListener(new ChangeListener() {
             @Override
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/DefaultDataSwingManager.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/DefaultDataSwingManager.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/DefaultDataSwingManager.java	(revision 44259)
@@ -64,7 +64,9 @@
 import org.gvsig.fmap.dal.swing.impl.featuretype.DefaultFeatureTypeAttributePanel;
 import org.gvsig.fmap.dal.swing.impl.featuretype.DefaultFeatureTypePanel;
 import org.gvsig.fmap.dal.swing.impl.jdbc.DefaultJDBCConnectionPanel;
+import org.gvsig.fmap.dal.swing.impl.searchpanel.DefaultSearchPanel;
 import org.gvsig.fmap.dal.swing.jdbc.JDBCConnectionPanel;
+import org.gvsig.fmap.dal.swing.searchpanel.FeatureStoreSearchPanel;
 import org.gvsig.tools.dynform.DynFormLocator;
 import org.gvsig.tools.dynobject.DynClass;
 import org.gvsig.tools.dynobject.DynStruct;
@@ -130,10 +132,10 @@
             builder.setPreviewSymbolTable(featureSymbolTable.createParent());
         }
         builder.addSymbolTable(featureSymbolTable);
-        DefaultFeatureStoreElement storeElement = new DefaultFeatureStoreElement(builder, store);
+        DefaultFeatureStoreElement storeElement = new DefaultFeatureStoreElement(store);
         builder.addElement(storeElement);
         if( store.getProviderFactory().hasSQLSupport()==DataStoreProviderFactory.YES ) {
-            builder.setSQLCompatible(true);
+            builder.getPreferences().setSQLCompatible(true);
         }
         builder.expandElement(storeElement);
         return builder;
@@ -233,8 +235,16 @@
     }
 
     @Override
-    public FeatureStoreElement createFeatureStoreElement(ExpressionBuilderConfig configPanel) {
-        FeatureStoreElement e = new DefaultFeatureStoreElement(configPanel, null);
+    public FeatureStoreElement createFeatureStoreElement() {
+        FeatureStoreElement e = new DefaultFeatureStoreElement(null);
         return e;
     }
+
+    @Override
+    public FeatureStoreSearchPanel createFeatureStoreSearchPanel(FeatureStore store) {
+        DefaultSearchPanel e = new DefaultSearchPanel(store);
+        return e;
+    }
+
+    
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/DefaultDALSwingLibrary.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/DefaultDALSwingLibrary.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/DefaultDALSwingLibrary.java	(revision 44259)
@@ -39,6 +39,7 @@
 import org.gvsig.fmap.dal.swing.impl.dataStoreParameters.DefaultDataStoreParametersPanelManager;
 import org.gvsig.fmap.dal.swing.impl.dynobjectutils.CreateComboModelFromTable;
 import org.gvsig.fmap.dal.swing.impl.expressionevaluator.FeatureStoreElementFactory;
+import org.gvsig.fmap.dal.swing.impl.searchpanel.DefaultSearchPanel;
 import org.gvsig.tools.ToolsLocator;
 import org.gvsig.tools.dynobject.DynObjectManager;
 import org.gvsig.tools.library.AbstractLibrary;
@@ -75,12 +76,15 @@
         try {
             JDynFormFieldFeatureLinkFactory.selfRegister();
             JDynFormFieldFeaturesTableLinkFactory.selfRegister();
+            
             JDynFormFieldImageByteArrayFactory.selfRegister();
             JDynFormFieldImageFileFactory.selfRegister();
             JDynFormFieldImageURLFactory.selfRegister();
             JDynFormFieldForeingKeyFactory.selfRegister();
             JDynFormFieldSelectableForeingKeyFactory.selfRegister();
             JDynFormFieldFeaturesFactory.selfRegister();
+            
+            DefaultSearchPanel.selfRegister();
 
             DynObjectManager dynObjectmanager = ToolsLocator.getDynObjectManager();
             dynObjectmanager.registerDynMethod(new CreateComboModelFromTable("DAL.createComboModelFromTable", "XXXXXXXXXXXXXXXXXXXX."));
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/expressionevaluator/DefaultFeatureStoreElement.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/expressionevaluator/DefaultFeatureStoreElement.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/expressionevaluator/DefaultFeatureStoreElement.java	(revision 44259)
@@ -2,6 +2,7 @@
 
 import org.gvsig.fmap.dal.swing.expressionevaluator.FeatureStoreElement;
 import java.util.ArrayList;
+import java.util.Collection;
 import java.util.Collections;
 import java.util.Comparator;
 import java.util.Iterator;
@@ -16,31 +17,27 @@
 import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
 import org.gvsig.fmap.dal.feature.FeatureStore;
 import org.gvsig.fmap.dal.feature.FeatureType;
+import org.gvsig.fmap.dal.swing.impl.searchpanel.SearchUtils;
 
 /**
  *
  * @author jjdelcerro
  */
-public class DefaultFeatureStoreElement 
+@SuppressWarnings("UseSpecificCatch")
+public class DefaultFeatureStoreElement
         extends AbstractElement
-        implements FeatureStoreElement , SimpleElement
-{
+        implements FeatureStoreElement, SimpleElement {
 
     private FeatureStore store;
     private FeatureType type;
     private List<Element> elements;
-    private final ExpressionBuilderConfig config;
     private String myName;
 
-    @SuppressWarnings("OverridableMethodCallInConstructor")
-    public DefaultFeatureStoreElement(ExpressionBuilderConfig config, FeatureStore store) {
-        super("store", "expressionbuilder-element-table");
-        this.config = config;
-        if( store!=null ) {
-            this.setFeatureStore(store);
-        }
+    public DefaultFeatureStoreElement(FeatureStore store) {
+        super("store", "store", "expressionbuilder-element-table");
+        this.setFeatureStore(store);
     }
-    
+
     @Override
     public Element get(int index) {
         return this.elements.get(index);
@@ -50,10 +47,10 @@
     public void setName(String name) {
         this.myName = name;
     }
-    
+
     @Override
     public String getName() {
-        if( !StringUtils.isBlank(this.myName) ) {
+        if (!StringUtils.isBlank(this.myName)) {
             return this.myName;
         }
         if (this.store == null) {
@@ -82,7 +79,7 @@
 
     @Override
     public List<Element> getElements() {
-        if( this.elements == null ) {
+        if (this.elements == null) {
             return Collections.EMPTY_LIST;
         }
         return Collections.unmodifiableList(this.elements);
@@ -100,32 +97,12 @@
 
     @Override
     public void setFeatureStore(FeatureStore store) {
-          if (store==null) {
-              this.elements = Collections.EMPTY_LIST;
-              return;
-          }
-          try {
-            
-            this.store = store;
-            this.type = this.store.getDefaultFeatureType();
-            this.elements = new ArrayList<>();
-            for (FeatureAttributeDescriptor attrdesc : type) {
-                this.elements.add(new FeatureAttributeElement(
-                                this.config,
-                                this.store,
-                                attrdesc
-                        )
-                );
-            }
-            Collections.sort(elements, new Comparator<Element>() {
-                @Override
-                public int compare(Element o1, Element o2) {
-                    return o1.getName().compareTo(o2.getName());
-                }
-            });
-        } catch (DataException ex) {
-            throw new RuntimeException(ex);
+        if (store == null) {
+            this.elements = Collections.EMPTY_LIST;
+            return;
         }
+        this.store = store;
+        this.buildElements();
     }
 
     @Override
@@ -133,5 +110,34 @@
         return this.store;
     }
 
-    
+    @Override
+    public Element setConfig(ExpressionBuilderConfig config) {
+        super.setConfig(config);
+        this.buildElements();
+        return this;
+    }
+
+    private void buildElements() {
+        if( this.store == null || this.getConfig()==null ) {
+            return;
+        }
+        try {
+            this.type = this.store.getDefaultFeatureType();
+            
+            this.elements = new ArrayList<>();
+            Collection<FeatureAttributeDescriptor> attributes = SearchUtils.getOrderedAttributes(
+                    type, 
+                    SearchUtils.ALL_FILTER, 
+                    SearchUtils.LABEL_ORDER, 
+                    -1
+            );
+            for (FeatureAttributeDescriptor attrdesc : attributes) {
+                Element element = new FeatureAttributeElement(this.store,attrdesc);
+                element.setConfig(this.getConfig());
+                this.elements.add(element);
+            }
+        } catch (Exception ex) {
+            throw new RuntimeException(ex);
+        }
+    }
 }
